package yhf.com.viewpagedemo;

import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.content.Context;
import android.os.Build;
import android.os.Handler;
import android.os.Message;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.squareup.picasso.Picasso;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by at. on 2019/5/24.
 */

public class ADHelper {

    PageAdvImgAdapter adapter;


    /* 广告图*/
    private final int ADV = 0;//广告常量
    private int bannerIndex = 0;//Banner显示索引
    private boolean isChangeBanner = true;//是否跟新Banner
    private List<ImageView> mViewList = new ArrayList<ImageView>();//图片集合
    private ViewPager mAdvPager;//图片
    private int second = 2000;//图片切换时间（毫秒）

    PageClick click;

    Context mContext;

    List<String> adList = new ArrayList<>();
    List<ImageView> mDotView = new ArrayList<>();

    private Handler mHandler = new Handler() {
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case ADV:
                    advImgSwitch();
                    break;
            }
            super.handleMessage(msg);
        }
    };
    /**
     * 图片切换线程
     */
    private Runnable mAdvImgSwitch = new Runnable() {
        @Override
        public void run() {
            mHandler.sendEmptyMessage(ADV);
            mHandler.postDelayed(this, second);
        }
    };

    public ADHelper(ViewPager viewPager,Context mContext){
        this.mAdvPager = viewPager;
        this.mContext = mContext;

//        initView();
    }

    public void setImageList(List<String> adList){
        this.adList = adList;
        initView();
    }

    public void setPageClick(PageClick click){
        this.click = click;
    }

    public interface PageClick{
        public void onClick(int index);
    }

    private void initView(){

        final List<ImageView> mDotView = new ArrayList<>();

        for (int i = 0; i < adList.size(); i++) {
            ImageView mImage = new ImageView(mContext);

            Picasso.with(mContext).load(adList.get(i)).transform(new PicassoUtil(mContext,30)).into(mImage);
            mImage.setScaleType(ImageView.ScaleType.FIT_XY);
            mImage.setTag(i+"");
            if(i == 0 ){
                ImageView img = new ImageView(mContext);
                img.setScaleType(ImageView.ScaleType.FIT_XY);
                Picasso.with(mContext).load(adList.get(adList.size()-1)).transform(new PicassoUtil(mContext,30)).into(img);
                img.setTag((adList.size()-1)+"");
                mViewList.add(img);
            }
            mViewList.add(mImage);
            if(i == adList.size() - 1){
                ImageView img = new ImageView(mContext);
                img.setScaleType(ImageView.ScaleType.FIT_XY);
                Picasso.with(mContext).load(adList.get(0)).transform(new PicassoUtil(mContext,30)).into(img);
                img.setTag("0");
                mViewList.add(img);
            }

        }

        for (ImageView image : mViewList){
            image.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    int count = Integer.valueOf(view.getTag().toString());
                    if(click != null){
                        click.onClick(count);
                    }
                }
            });
        }

        mAdvPager.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrollStateChanged(int arg0) {
            }

            @Override
            public void onPageScrolled(int arg0, float arg1, int arg2) {
            }

            @Override
            public void onPageSelected(final int arg0) {
                bannerIndex = arg0;
                if(arg0>=1 && arg0 <= adList.size()){
                    for (int i = 0; i < mDotView.size(); i++) {
                    }
                }
                mHandler.postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        if (arg0 == mViewList.size() - 1) {
                            mAdvPager.setCurrentItem(1, false);
                        } else if (arg0 == 0) {
                            mAdvPager.setCurrentItem(mViewList.size() - 2, false);
                        }
                    }
                }, 200);
            }
        });
        mAdvPager.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                switch (event.getAction()) {
                    //按下和拖动的时候广告图片不切换
                    case MotionEvent.ACTION_DOWN:
                    case MotionEvent.ACTION_MOVE:
                        isChangeBanner = false;
                        break;
                    //松开恢复广告可以切换
                    case MotionEvent.ACTION_UP:
                    case MotionEvent.ACTION_CANCEL:
                        isChangeBanner = true;
                        break;
                }
                return false;
            }
        });
        adapter = new PageAdvImgAdapter(mViewList);
        mAdvPager.setAdapter(adapter);
        mAdvPager.setPageMargin(50);
        mAdvPager.setPageTransformer(true, new CardTransformer());
        mAdvPager.setCurrentItem(1);
        //图片滚动控件加入标记
//        mIndicator = (PageIndicator) child.findViewById(R.id.indicator);

        for (int i = 0; i < adList.size(); i++) {
            ImageView imageView = new ImageView(mContext);
            LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT));
            params.leftMargin = 10;
            params.rightMargin = 10;
//            if (i == 0) {
//                imageView.setBackgroundResource(R.drawable.bg_details_photo_viewindicator_red);
//            } else {
//                imageView.setBackgroundResource(R.drawable.bg_details_photo_viewindicator_grey);
//            }
//            cycleLayout.addView(imageView,params);
            mDotView.add(imageView);
        }

        if (mViewList.size() > 1) {
//            mIndicator.setViewPager(mAdvPager);
            mHandler.post(mAdvImgSwitch);
        }
    }

    /**
     * 图片广告切换
     */
    private void advImgSwitch() {
        if (isChangeBanner) {
            mAdvPager.setCurrentItem(bannerIndex);
            if ((bannerIndex + 1) == mViewList.size()) {
                bannerIndex = 0;
            } else {
                bannerIndex++;
            }
        }
    }

    private class PageAdvImgAdapter extends PagerAdapter {

        private List<ImageView> mViewList;//图片广告集合

        public PageAdvImgAdapter(List<ImageView> mViewList){
            this.mViewList=mViewList;
        }

        @Override
        public boolean isViewFromObject(View arg0, Object arg1) {
            return arg0 == arg1;
        }

        @Override
        public int getCount() {
            return mViewList.size();
        }

        @Override
        public void destroyItem(ViewGroup container, int position, Object object) {
            if ((position + 1) <= mViewList.size()) {
                ImageView iv = mViewList.get(position);
                container.removeView(iv);
            }
        }

        @Override
        public int getItemPosition(Object object) {
            return POSITION_NONE;
        }

        @Override
        public Object instantiateItem(ViewGroup container, int position) {
            container.addView(mViewList.get(position));
            return mViewList.get(position);
        }
    }


    private class CardTransformer implements ViewPager.PageTransformer {
        private static final float MIN_SCALE = 0.8f;
        private static final float MIN_ALPHA = 0.8f;


        private static final float MAX_SCALE = 1.0f;
        private static final float MAX_ALPHA = 1.0f;


        @TargetApi(Build.VERSION_CODES.HONEYCOMB)
        @SuppressLint("NewApi")
        public void transformPage(View view, float position) {
            if (position < -1) {
                view.setScaleY(MIN_SCALE);
                view.setAlpha(MIN_ALPHA);
            } else if (position == 0) {
                view.setScaleY(MAX_SCALE);
                view.setAlpha(MAX_ALPHA);
            } else if (position <= 1) {
                float scaleFactor = MIN_SCALE + (1 - MIN_SCALE) * (1 - Math.abs(position));
                float alphaFactor = MIN_ALPHA + (1 - MIN_ALPHA) * (1 - Math.abs(position));
                view.setScaleY(scaleFactor);
                view.setAlpha(alphaFactor);
            } else {
                view.setScaleY(MIN_SCALE);
                view.setAlpha(MIN_ALPHA);
            }
        }
    }

}
