package yhf.com.viewpagedemo;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapShader;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.PorterDuff;
import android.graphics.PorterDuffXfermode;
import android.graphics.Rect;
import android.graphics.RectF;

import com.squareup.picasso.Transformation;

/**
 * Created by at. on 2019/6/5.
 */

public class PicassoUtil  implements Transformation {

    private Context mContext;
    private int radius; // 圆形图片半径

    public PicassoUtil(Context context,int radius) {
        mContext = context;
        this.radius = dp2px(mContext, radius);
    }
    public int dp2px(Context context, double dp) {
        final float scale = context.getResources().getDisplayMetrics().density;
        return (int) (dp * scale + 0.5f);
    }

    @Override
    public Bitmap transform(Bitmap source) {

        //获取宽,高
        int width = source.getWidth();
        int height = source.getHeight();
            Bitmap.Config config = source.getConfig() != null ? source.getConfig() : Bitmap.Config.ARGB_8888;
//创建一张可以操作的正方形图片的位图
        Bitmap bitmap = Bitmap.createBitmap(width, height, config);
//创建一个画布Canvas
        Canvas canvas = new Canvas(bitmap);
//创建画笔
        Paint paint = new Paint();
        BitmapShader shader = new BitmapShader(source, BitmapShader.TileMode.CLAMP,BitmapShader.TileMode.CLAMP);
        paint.setShader(shader);
        paint.setAntiAlias(true);
        canvas.drawRoundRect(new RectF(0, 0, width, height), radius, radius, paint);
        source.recycle();
        return bitmap;

    }

    @Override
    public String key() {
        return "circle";
    }

}